function csfVal = csfFunc2_dst(sfreq,motion,csfType,frameRate, shift)
if(csfType == 0)
    %Daly CSF function
    %vr should be calculated
%     motion = zeros(size(motion)); %motion 0 for miqe 
    sfreq = sfreq + shift;% murat - shift
    vMin = 0.15;
    vMax = 80;
    gSP = 0.82;
    vI = motion * frameRate ./ sfreq;
    vE = min(gSP * vI + vMin, vMax);
    vR = abs(vI - vE);% murat +0.001; 
    csfVal = stcsfDaly2(sfreq,vR);
elseif(csfType == 1)
    %Kelly CSF function
    %temporal frequency should be computed
    tfreq = frameRate * motion;
    csfVal = stcsfKelly(sfreq,tfreq,0);
end