function [q1,q2]=li_mtd(imorg,imdist)
distArr = {};
orgArr = {};
restArr = {};
impArr = {};

% %gamma correction
% % display device black-level offset (sRGB)
% b = 0;
% % display device pixel-value-to-voltage gain (sRGB)
% k = 0.02874;
% % display device gamma (sRGB)
% g = 2.2;
% % initialize the pixel-value-to-luminance lookup table
% pixel_vals = -255:255;
% pix2lum_table =abs((b + k*pixel_vals)).^g;
% for row = 1 : size(imorg)     
%     imorg(row,:) = pix2lum_table(imorg(row,:)+256);
% end
% for row = 1 : size(imdist)     
%     imdist(row,:) = pix2lum_table(imdist(row,:)+256);
% end

% load jpeg2000mat8;
% imorg = double(rgb2gray(im512));
reflev = 4;
ref = double(dwt2d(imorg,reflev,'97'));
% imdist = dwt2d(imorg,1,'97');
% rec = idwt2d(ref,reflev,'97');
[rowSz,colSz] = size(imorg);
levSz = rowSz / (2^(reflev));
levSzPrv = 1;
ind = 1;
for kk =1:reflev
    if (kk == 1)
        orgArr{ind} = ref(1:levSz,1:levSz);
        ind = ind +1;
    end
    orgArr{ind}     = ref(levSz+1:2*levSz,1:levSz);
    orgArr{ind + 1} = ref(levSz+1:2*levSz,levSz+1:2*levSz);
    orgArr{ind + 2} = ref(1:levSz,levSz+1:2*levSz);
    ind = ind + 3;
    levSz = 2*levSz;
end


if(size(imdist,1) == size(imorg,1))
    test = double(dwt2d(imdist,reflev,'97'));
    doh = 3;
    N = rowSz * colSz;
else
    test = double(dwt2d(imdist,reflev-1,'97'));
    doh = 6;
    N = rowSz * colSz;
end

levSz = rowSz / (2^(reflev));
ind = 1;


for kk =1:reflev
    if (kk == 1)
        distArr{ind} = test(1:levSz,1:levSz);
        ind = ind +1;
    end
    if( (size(imdist,1) == size(imorg,1)) || (kk < reflev))
        distArr{ind}     = test(levSz+1:2*levSz,1:levSz);
        distArr{ind + 1} = test(levSz+1:2*levSz,levSz+1:2*levSz);
        distArr{ind + 2} = test(1:levSz,levSz+1:2*levSz);
    else
        distArr{ind}     = zeros(levSz);
        distArr{ind + 1} = zeros(levSz);
        distArr{ind + 2} = zeros(levSz);        
    end
    ind = ind + 3;
    levSz = 2*levSz;
end
ca = imorg;
psi_ind = [2:3:3*reflev+1]; % 2th and 4th orientation for psi difference check 

%2) Decoupling : Finding k coefficients with contrast enhancement and 
%Finding restored image k in [0,1], kk subband
psi_diff = 20; %>1
for subband = 1:3*reflev+1
%     if(any(subband ==  psi_ind))
%         psi_org = atan(orgArr{subband}./(orgArr{subband+2} + 10^(-20))) + pi * (sign(-orgArr{subband+2}) + 1)/2;
%         psi_dist = atan(distArr{subband}./(distArr{subband+2} + 10^(-20))) + pi * (sign(-orgArr{subband+2}) + 1)/2;
%         psi_diff = (psi_org - psi_dist)* 180 /pi;
%     end
    kArr{subband} = clip(distArr{subband}./(orgArr{subband}+10^(-40)),0,1);
    if((subband == 1) ) %|| (psi_diff <= 1)
        restArr{subband} = distArr{subband};
    else
        restArr{subband} = kArr{subband} .* orgArr{subband}; 
    end
    impArr{subband} = distArr{subband} - restArr{subband};
    psi_diff = 20;
end

% Reconstruct
levSz = rowSz / (2^(reflev));
ind = 1;
% noise = zeros(rowSz / 2);

for kk =1:reflev-1
    if (kk == 1)
        rest (1:levSz,1:levSz) = restArr{ind} ;
        ind = ind +1;
    end
    rest (levSz+1:2*levSz,1:levSz) = restArr{ind};
    rest (levSz+1:2*levSz,levSz+1:2*levSz)= restArr{ind + 1};
    rest (1:levSz,levSz+1:2*levSz) = restArr {ind + 2};        
    ind = ind + 3;
    levSz = 2*levSz;
end
levSz = rowSz / (2^(reflev));
ind = 1;
noise = zeros(rowSz / 2);
for kk =1:reflev-1
    if (kk == 1)
        noise (1:levSz,1:levSz) = impArr{ind} ;
        ind = ind +1;
    end
    noise (levSz+1:2*levSz,1:levSz) = impArr{ind};
    noise (levSz+1:2*levSz,levSz+1:2*levSz)= impArr{ind + 1};
    noise (1:levSz,levSz+1:2*levSz) = impArr {ind + 2};        
    ind = ind + 3;
    levSz = 2*levSz;
end
% rest2 = idwt2d(rest,reflev-1,'97');
% imtool(rest2/max(max(rest2)));
% imdist2 = blk2(imdist)
noise2 = idwt2d(noise,reflev-1,'97');
noise3 = blk2(noise2)
% imtool(noise2/max(max(noise2)));

% [eK] =  get_eK (noise);
%

%3) Performing CSF
%        pi . fs . d
%F(la) = ----------------,     H(w) = (a+bw) . exp(-cw)
%        180 . h . 2^(la)
%
%
a = 0.31, b= 0.69, c = 0.29;
fs = 256;
% doh = 4;
lambda = 1:3;
la_vec = [];
for ii = reflev : -1 : 1
    if(ii == reflev)
        la_vec = [la_vec ii*ones(1,4)];%lambda vector for each subband
    else
        la_vec = [la_vec ii*ones(1,3)];
    end
end
subband = 1:3*reflev+1;
% F_lambda1 = (pi * fs * doh)./(180 * 2.^(la_vec(subband)));

or_ind = [2:3:3*reflev+1 4:3:3*reflev+1];
or =-ones(1,3*reflev+1);
or(or_ind) = 1;
% w =  F_lambda ./(0.85 + 0.15 * or);
% H = (a+b*w).* exp(-c*w);  % CSF value for each subband
% doh = 8;
F_lambda = (pi * fs * doh)./(180 * 2.^(la_vec(subband)));
w =  F_lambda ./(0.85 + 0.15 * or);
H = (a+b*w).* exp(-c*w);  % CSF value for each subband
% end
w2 = (pi * (1:128) * doh)./180;
% H2 = (a+b*w2).* exp(-c*w2);  % CSF value for each subband
H2 = 59.8*w2.^(-0.1087*log(w2)-0.1258);
figure, plot(w2,H2)
% val = sum(H2.*noise3(1:end/2)); 


qnum1 = 0;
qden1 = 0;
qnum2 = 0;
qden2 = 0;

%4) Contrast Masking and Spatial Pooling
weightMat = (1/30)*ones(3);
weightMat(2,2) = 1/15;

bs = 2;
bf = 1;
for ii = 1:3*reflev+1
    orgArr{ii} = H(ii) * orgArr{ii};
    restArr{ii} =  H(ii) * restArr{ii};
    impArr{ii} = H(ii) * impArr{ii};

    noiseMask = conv2(abs(impArr{ii}),weightMat,'same');
    absRest = abs(restArr{ii}); 
    mRestArr{ii} = clip(absRest - noiseMask, 0 , 1000000);
    restMask = conv2(absRest,weightMat,'same');
    absImp = abs(impArr{ii});
    mImpArr{ii} = clip(absImp- restMask, 0 , 1000000);
    aOrgArr{ii} = abs(orgArr{ii});

    sW = 2^(2*(reflev - ceil((ii-1)/3)));
%     sW = 1;
%     qnum1 = qnum1 + sW*(sum(sum(mRestArr{ii}.^bs)))^(1/bs);
%     qden1 = qden1 + sW*(sum(sum(aOrgArr{ii}.^bs)))^(1/bs);
%     qnum2 = qnum2 + sW*(sum(sum(mImpArr{ii}.^bs)))^(1/bs);

    qnum1 = qnum1 + sW*(sum(sum(restArr{ii}.^bs)))^(1/bs);
    qden1 = qden1 + sW*(sum(sum(orgArr{ii}.^bs)))^(1/bs);
    qnum2 = qnum2 + sW*(sum(sum(impArr{ii}.^bs)))^(1/bs);


%     qden2 = qnum2 + sum(restArr{ii}.^bs).^(1/bs);
end
q1 = qnum1 / qden1;
q2 = qnum2 / N;
mn = mean2(imdist)
