function [metrix_value] = metrix_nqm(reference_image,query_image)


%%%
%%% veiwing angle is determined based on the assumption that
%%% the image is viewed at 3.5 picture heights away
%%%
viewing_angle = 1/3.5;

%%%
%%% estimate the dimesion of the image as the geometric mean
%%% of the horizonal and vertical dimensions
%%%
dim = sqrt( prod( size(reference_image) ));

metrix_value = nqm(reference_image, query_image, viewing_angle, dim);
