function [metrix_value] = vifdrNorm( reference_image, query_image )            
if(size(reference_image,1) == size(query_image,1))
    metrix_value = vifvec(double(reference_image),double(query_image)); %compressed QE
else
    data = zeros(size(reference_image));
    oc_dwt_im = overcomp_dwt2d(reference_image,1,'97');
    ll_im512 = oc_dwt_im(1:end/2,1:end/2);
    data(1:end/2,1:end/2) = query_image;
    us_dwt_im = idwt2d(data,1,'97');
    metrix_value = vifvec(ll_im512,double(us_dwt_im));  %Heuristic method 2 
end

